package cz.cvut.fel.alg;

/**
 * Playground for dynamic programming algorithms
 *
 * @author Petr Ryšavý, Karel Horák
 */
public class DynamicProgramming {

    public static void main(String[] args) {
        // use this method for debugging your code
        // you may also want to run our tests that are available in test packages (i.e. test directory)

        // Run tests
        for (int n = 0; n <= 10; n++) {
            for (int k = 0; k <= n; k++) {
                System.out.printf("%4d ", binomialDP(n, k));
            }
            System.out.println();
        }
        System.out.println();

        for (int i = 0; i <= 10; i++) System.out.println(numberOfValidStringsDP(i));
    }

    /**
     * Computes Fibonacci number using recursion
     *
     * @param n
     * @return F(n)
     */
    public static long fibonacciRecursive(int n) {
        throw new UnsupportedOperationException("Method DynamicProgramming::fibonacciRecursive is not implemented");
    }

    /**
     * Computes Fibonacci number using dynamic programming
     *
     * @param n
     * @return F(n)
     */
    public static long fibonacciDP(int n) {
        throw new UnsupportedOperationException("Method DynamicProgramming::fibonacciDP is not implemented");
    }

    /**
     * Computes binomial coefficient using recursion
     *
     * @param n
     * @param k
     * @return n \choose k
     */
    public static long binomialRecursive(int n, int k) {
        throw new UnsupportedOperationException("Method DynamicProgramming::binomialRecursive is not implemented");
    }

    /**
     * Computes binomial coefficient using dynamic programming
     *
     * @param n
     * @param k
     * @return n \choose k
     */
    public static long binomialDP(int n, int k) {
        throw new UnsupportedOperationException("Method DynamicProgramming::binomialDP is not implemented");
    }

    /**
     * Computes number of valid 0/1 strings of length n using recursion
     *
     * @param n
     * @return
     */
    public static long numberOfValidStringsRecursive(int n) {
        throw new UnsupportedOperationException("Method DynamicProgramming::numberOfValidStringsRecursive is not implemented");
    }

    /**
     * Computes number of valid 0/1 strings of length n using dynamic programming
     *
     * @param n
     * @return
     */
    public static long numberOfValidStringsDP(int n) {
        throw new UnsupportedOperationException("Method DynamicProgramming::numberOfValidStringsRecursive is not implemented");
    }

}
