package cz.cvut.fel.alg;

import java.util.Collection;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.junit.runners.MethodSorters;
import org.junit.runners.Parameterized;
import org.junit.runners.Parameterized.Parameters;

import static org.hamcrest.CoreMatchers.equalTo;
import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.*;

/**
 * Test class for Binomial coefficient.
 *
 * @author Petr Ryšavý, Karel Horák
 */
@FixMethodOrder(MethodSorters.NAME_ASCENDING)
@RunWith(Parameterized.class)
public class BinomialDPTest {

    @Parameters
    public static Collection<Object[]> data() {
        return BinomialRecursiveTest.data();
    }

    private final int n;
    private final int k;
    private final long binomialCoefficient;

    public BinomialDPTest(int n, int k, long binomialCoefficient) {
        this.n = n;
        this.k = k;
        this.binomialCoefficient = binomialCoefficient;
    }

    @Test
    public void testBinomialDP() {
        assertThat(DynamicProgramming.binomialDP(n, k), is(equalTo(binomialCoefficient)));
    }
}
