package cz.cvut.fel.alg;

import java.util.Arrays;
import java.util.Collection;
import static org.hamcrest.CoreMatchers.equalTo;
import org.junit.Test;
import static org.junit.Assert.*;
import org.junit.FixMethodOrder;
import org.junit.runners.MethodSorters;
import static org.hamcrest.CoreMatchers.is;
import org.junit.runner.RunWith;
import org.junit.runners.Parameterized;
import org.junit.runners.Parameterized.Parameters;

/**
 * Test class for Binomial coefficient.
 *
 * @author Petr Ryšavý, Karel Horák
 */
@FixMethodOrder(MethodSorters.NAME_ASCENDING)
@RunWith(Parameterized.class)
public class BinomialRecursiveTest {

    @Parameters
    public static Collection<Object[]> data() {
        return Arrays.asList(new Object[][]{
            {0, 0, 1}, {1,0, 1}, {1,1,1}, {2,0,1}, {2,1,2}, {2,2,1}, {3,0,1}, {3,1,3}, {3,2,3}, {3,3,1}, {4,0,1}, {4,1,4}, {4,2,6}, {4,3,4}, {4,4,1}, {5,0,1}, {5,1,5}, {5,2,10}, {5,3,10}, {5,4,5}, {5,5,1}, {8,3,56},{30,0,1}, {30,1,30}, {30,29,30}, {30,30,1}, {30,17,119759850}, {33,17,1166803110}
        });
    }

    private final int n;
    private final int k;
    private final long binomialCoefficient;

    public BinomialRecursiveTest(int n, int k, long binomialCoefficient) {
        this.n = n;
        this.k = k;
        this.binomialCoefficient = binomialCoefficient;
    }

    @Test
    public void testBinomialRecursive() {
        assertThat(DynamicProgramming.binomialRecursive(n, k), is(equalTo(binomialCoefficient)));
    }
}
