package cz.cvut.fel.alg;

import java.util.Arrays;
import java.util.Collection;
import static org.hamcrest.CoreMatchers.equalTo;
import org.junit.Test;
import static org.junit.Assert.*;
import org.junit.FixMethodOrder;
import org.junit.runners.MethodSorters;
import static org.hamcrest.CoreMatchers.is;
import org.junit.runner.RunWith;
import org.junit.runners.Parameterized;
import org.junit.runners.Parameterized.Parameters;

/**
 * Test class for Fibonacci.
 *
 * @author Petr Ryšavý, Karel Horák
 */
@FixMethodOrder(MethodSorters.NAME_ASCENDING)
@RunWith(Parameterized.class)
public class FibonacciRecursiveTest {

    @Parameters
    public static Collection<Object[]> data() {
        return Arrays.asList(new Object[][]{
            // uncomment fibonacci(80) if you want to be really patient with recursive implementation
            {0, 0}, {1, 1}, {2, 1}, {3, 2}, {4, 3}, {5, 5}, {6, 8}, {7, 13}, {8, 21}, {9, 34}, {10, 55}, {11, 89}, {12, 144}, {20, 6765}, {40, 102334155}, {45, 1134903170}, //{80, 23416728348467685L}
        });
    }

    private final int fInput;
    private final long fExpected;

    public FibonacciRecursiveTest(int fInput, long fExpected) {
        this.fInput = fInput;
        this.fExpected = fExpected;
    }

    @Test
    public void testFibonacciRecursive() {
        assertThat(DynamicProgramming.fibonacciRecursive(fInput), is(equalTo(fExpected)));
    }
}
