package cz.cvut.fel.alg;

import java.util.Collection;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.junit.runners.MethodSorters;
import org.junit.runners.Parameterized;
import org.junit.runners.Parameterized.Parameters;

import static org.hamcrest.CoreMatchers.equalTo;
import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.*;

/**
 * Test class for Fibonacci.
 *
 * @author Petr Ryšavý, Karel Horák
 */
@FixMethodOrder(MethodSorters.NAME_ASCENDING)
@RunWith(Parameterized.class)
public class NoStringsDPTest {

    @Parameters
    public static Collection<Object[]> data() {
        return NoStringsRecursiveTest.data();
    }

    private final int fInput;
    private final long fExpected;

    public NoStringsDPTest(int fInput, long fExpected) {
        this.fInput = fInput;
        this.fExpected = fExpected;
    }

    @Test
    public void testNumberOfValidStringsDP() {
        assertThat(DynamicProgramming.numberOfValidStringsDP(fInput), is(equalTo(fExpected)));
    }
}
