package cz.cvut.fel.alg;

import java.util.Arrays;
import java.util.Collection;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.junit.runners.MethodSorters;
import org.junit.runners.Parameterized;
import org.junit.runners.Parameterized.Parameters;

import static org.hamcrest.CoreMatchers.equalTo;
import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.*;

/**
 * Test class for Fibonacci.
 *
 * @author Petr Ryšavý, Karel Horák
 */
@FixMethodOrder(MethodSorters.NAME_ASCENDING)
@RunWith(Parameterized.class)
public class NoStringsRecursiveTest {

    @Parameters
    public static Collection<Object[]> data() {
        return Arrays.asList(new Object[][]{
            {0,0},{1,2},{2,3},{3,5},{4,8},{5,13},{10,144},{20,17711},{30,2178309},{40,267914296},{44,1836311903}
        });
    }

    private final int fInput;
    private final long fExpected;

    public NoStringsRecursiveTest(int fInput, long fExpected) {
        this.fInput = fInput;
        this.fExpected = fExpected;
    }

    @Test
    public void testNumberOfValidStringsRecursive() {
        assertThat(DynamicProgramming.numberOfValidStringsRecursive(fInput), is(equalTo(fExpected)));
    }
}
